/**
 * Created by aaron on 17/2/10.
 */
import React,{Component, PureComponent} from 'react';
import PropTypes from 'prop-types';

import {
    Text,
    View,
} from 'react-native';

import {
    BaseViewComponent
} from 'wm-react-native-base';

/**
 * 封装View
 */
export default class WMView extends BaseViewComponent{

    /**
     *
     * @type {{}}
     */
    static propTypes = {
        isShow:PropTypes.bool,  //是否显示
    };

    /**
     *
     * @type {{isShow: boolean}}
     */
    static defaultProps = {
        isShow:true,
    }

    // 构造
    constructor(props) {
        super(props);

        const { isShow, children } = this.props;
        this.state = {isShow:isShow, children:children}
    }

    componentWillReceiveProps(nextProps){
        if(nextProps){
            this.setState({...nextProps});
        }
    }

    render(){
        if(!this.state.isShow){
            return null;
        }
        return (
            <View ref={'wmView'} opacity={1} {...this.props}>
                {this.props.children}
            </View>
        );
    }

    /**
     *
     * @param props
     */
    setNativeProps = (props)=>{
        this.refs.wmView && this.refs.wmView.setNativeProps(props);
    }

    /**
     * 当前是否已经显示
     */
    isShow = ()=>{
        return this.state.isShow;
    }

    /**
     * 隐藏
     */
    hidden = (callback)=>{
        this.setState({isShow:false}, callback);
    }

    /**
     * 显示
     */
    show = (callback)=>{
        this.setState({isShow:true}, callback);
    }

}